using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Bricksoft.IM.MSN;
using System.Timers;

namespace Bricksoft.IM.MSN.Demo
{
    public partial class FrmChatSession : Form
    {
        private System.Timers.Timer timerTyping = new System.Timers.Timer();


        public FrmChatSession()
        {
            InitializeComponent();

            timerTyping.Interval = 5000;
            timerTyping.Elapsed += timerTypingElapsed;
            timerTyping.Enabled = true;
        }

        private void timerTypingElapsed(object sender, ElapsedEventArgs e)
        {
            try
            { 
                timerTyping.Enabled = false; 

                lblStatus.Text = "";
            }
            finally
            { timerTyping.Enabled = true; };
            
        }

        private void btnSendMessage_Click(object sender, EventArgs e)
        {
            if (txtMsg.Text != "")
            {
                TextMessage msg = new TextMessage();
                msg.Text = txtMsg.Text ;
                (Tag as MSNChatSession).SendMessage(msg);
            }
                
        }

        public void buddyEnter(string buddy)
        {
            lbBuddies.Items.Add(buddy);
        }

        public void buddyLeave(string buddy)
        {
            lbBuddies.Items.Remove(buddy);
        }

        public void messageReceived(string message)
        {
            txtChat.Text = message + txtChat.Text;
        }

        public void typingMessageReceived(string buddy)
        {
           lblStatus.Text = buddy;
        }

        private void txtMsg_EnabledChanged(object sender, EventArgs e)
        {

        }

        private void txtMsg_Enter(object sender, EventArgs e)
        {
            (Tag as MSNChatSession).SendTypingMessage();
        }

        private void btnInvite_Click(object sender, EventArgs e)
        {
            InputMessageForm frmInput = new InputMessageForm();
            frmInput.setCaption("Buddy:");
            frmInput.ShowDialog();

            if ((frmInput.Result == DialogResult.OK) && (frmInput.MessageStr != ""))
            {
                (Tag as MSNChatSession).Invite(frmInput.MessageStr);
            }
        }

        private void FrmChatSession_FormClosed(object sender, FormClosedEventArgs e)
        {
           if (Tag != null)
           {
               (Tag as MSNChatSession).Tag = null;
               Tag = null;
           }
        }

        private void FrmChatSession_FormClosing(object sender, FormClosingEventArgs e)
        {
        }
    }
}