﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Web;
using Bricksoft;
using Bricksoft.IM.MSN;

namespace Bricksoft.IM.MSN.Demo
{
    public partial class frmMSNRobot : Form
    {
        private MSNClient msn;
        private Timer timerKeepAlive;
        private TreeNode rootNode;

        public frmMSNRobot()
        {
            InitializeComponent();

            msn = new MSNClient();
            msn.OnError += MSN_OnError;
            msn.OnLog += MSN_OnLog;
            msn.OnReceiveBuddyList += MSN_OnReceiveBuddyList;
            msn.OnReceiveGroupList += MSN_OnReceiveGroupList;
            msn.OnLogin += MSN_OnLogin;
            msn.OnLogout += MSN_OnLogout;
            msn.OnTextMessageReceived += MSN_OnTextMessageReceived;
            msn.OnStatusChanged += MSN_OnStatusChanged;
            msn.OnNicknameChanged += MSN_OnNicknameChanged;
            msn.OnBuddyStatusChanged += MSN_OnBuddyStatusChanged;
            msn.OnDeleteBuddy += MSN_OnDeleteBuddy;
            msn.OnBuddyAddYouRequest += MSN_OnBuddyAddYouRequest;
            msn.OnAddBuddy += MSN_OnAddBuddy;
            msn.OnChatSessionBuddyTyping += MSN_OnChatSessionBuddyTyping;
            msn.OnOfflineMessageReceived += MSN_OnOfflineMessageReceived;
            msn.OnChatSessionStart += MSN_OnChatSessionStart;
            msn.OnChatSessionStop += MSN_OnChatSessionStop;
            msn.OnChatSessionBuddyEnter += MSN_OnChatSessionBuddyEnter;
            msn.OnChatSessionBuddyLeave += MSN_OnChatSessionBuddyLeave;
            msn.OnTextMessageSent += MSN_OnTextMessageSent;
            msn.OnPersonalMessageChanged += MSN_OnPersonalMessageChanged;
            msn.OnMPOP += MSN_OnMPOP;
           
            msn.Status = MSNStatus.msnOnline;

            mmAction.Enabled = false;

            timerKeepAlive = new Timer();
            timerKeepAlive.Interval = 5000;
            timerKeepAlive.Tick += new EventHandler(timerKeepAliveExecute);
            //timerKeepAlive.Start();

            //msn.SamePersonalMessageEverywhere = true;
            msn.GetOIMEnable = true;
        }

        private void OnMPOP(object sender, EventArgs e)
        {
            mmLogout.DropDownItems.Clear();

            if (msn.MPOPList.Count <= 1) return;

            System.Windows.Forms.ToolStripMenuItem mItem = null;

            foreach (System.Collections.DictionaryEntry o in msn.MPOPList)
            {
                MSNMPOP mpop = (MSNMPOP)o.Value;

                if (mpop.MachineId == msn.MachineId)
                    mItem = (System.Windows.Forms.ToolStripMenuItem)mmLogout.DropDownItems.Add("Logout from here (" + mpop.MachineName + ")");
                else
                    mItem = (System.Windows.Forms.ToolStripMenuItem)mmLogout.DropDownItems.Add("Logout from " + mpop.MachineName);

                mItem.Tag = mpop;

                mItem.Click += logoutToolStripMenuItem_Click;
            }

            mItem = (System.Windows.Forms.ToolStripMenuItem)mmLogout.DropDownItems.Add("Logout from everywhere");

            mItem.Tag = null;

            mItem.Click += logoutToolStripMenuItem_Click;
        }

        private void OnChatSessionBuddyTyping(object sender, MSNChatSession chatSession, string buddy)
        {
            if (chatSession.Tag == null) return;

            FrmChatSession frmChat = chatSession.Tag as FrmChatSession;

            frmChat.typingMessageReceived(buddy + " is typing...");

            frmChat.Show();
        }

        private void MSN_OnChatSessionBuddyTyping(object sender, MSNChatSession chatSession, string buddy)
        {
            this.Invoke(new OnChatSessionBuddyEventHandle(OnChatSessionBuddyTyping), new object[] { sender, chatSession, buddy });
        }

        private void OnTextMessageSent(object sender, MSNChatSession chatSession, TextMessage message)
        {
            if (chatSession.Tag == null) return;

            FrmChatSession frmChat = chatSession.Tag as FrmChatSession;

            frmChat.messageReceived(msn.Account + " Said: " + message.Text + "\r\n");

            frmChat.Show();
        }

        private void MSN_OnTextMessageSent(object sender, MSNChatSession chatSession, TextMessage message)
        {
            this.Invoke(new OnTextMessageEventHandler(OnTextMessageSent), new object[] { sender, chatSession, message });
        }

        private void OnChatSessionBuddyEnter(object sender, MSNChatSession chatSession, string buddy)
        {
            if (chatSession.Tag == null) return;

            FrmChatSession frmChat = chatSession.Tag as FrmChatSession;

            frmChat.Show();

            frmChat.buddyEnter(buddy);
        }

        private void MSN_OnChatSessionBuddyEnter(object sender, MSNChatSession chatSession, string buddy)
        {
            this.Invoke(new OnChatSessionBuddyEventHandle(OnChatSessionBuddyEnter), new object[] { sender, chatSession, buddy });
        }

        private void OnChatSessionBuddyLeave(object sender, MSNChatSession chatSession, string buddy)
        {
            if (chatSession.Tag == null) return;

            FrmChatSession frmChat = chatSession.Tag as FrmChatSession;
            frmChat.Show();

            frmChat.buddyLeave(buddy);
        }

        private void MSN_OnChatSessionBuddyLeave(object sender, MSNChatSession chatSession, string buddy)
        {
            this.Invoke(new OnChatSessionBuddyEventHandle(OnChatSessionBuddyLeave), new object[] { sender, chatSession, buddy });
        }

        private void OnChatSessionStart(object sender, MSNChatSession chatSession)
        {
            FrmChatSession frmChat = new FrmChatSession();
            frmChat.Show();

            chatSession.Tag = frmChat;
            frmChat.Tag = chatSession;
        }

        private void MSN_OnChatSessionStart(object sender, MSNChatSession chatSession)
        {
            this.Invoke(new OnChatSessionEventHandle(OnChatSessionStart), new object[] { sender,chatSession});
        }

        private void OnChatSessionStop(object sender, MSNChatSession chatSession)
        {
            if (chatSession.Tag != null)
            {
                (chatSession.Tag as FrmChatSession).Hide();

                (chatSession.Tag as FrmChatSession).Tag = null;

                chatSession.Tag = null;
            }
        }

        private void MSN_OnChatSessionStop(object sender, MSNChatSession chatSession)
        {
            this.Invoke(new OnChatSessionEventHandle(OnChatSessionStop), new object[] { sender, chatSession });
        }

        private void OnOfflineMessageReceived(object sender, string buddy, string message,DateTime receivedTime)
        {
            txtLog.Text = buddy + " Sent " + receivedTime.ToLocalTime() + ": " + message + "\r\n" + txtLog.Text;
            lblStatus.Text = "Receive offline message from " + buddy;    
        }

        private void MSN_OnOfflineMessageReceived(object sender, string buddy, string message,DateTime receivedTime )
        {
            this.Invoke(new OnOfflineMessageEventHandler(OnOfflineMessageReceived), new object[] { sender, buddy, message,receivedTime});
        }       

        private void OnAddBuddy(object sender, string buddy)
        {
            MSNBuddy b = (sender as MSNClient).BuddyList[buddy] as MSNBuddy;

            TreeNode gn = FindNode(rootNode, b.GroupID);

            TreeNode bn = new TreeNode(b.Nickname);
            bn.Tag = b;
            b.Tag = bn;

            if (gn == null)
                rootNode.Nodes.Add(bn);
            else
                gn.Nodes.Add(bn);
        }

        private void MSN_OnAddBuddy(object sender, string buddy)
        {
            this.Invoke(new OnBuddyEventHandle(OnAddBuddy), new object[] {  sender,  buddy });
        }

        private void OnBuddyAddYouRequest(object sender, string buddy,ref bool bAccept)
        {
            if (MessageBox.Show(buddy + " added you. Do you want " + buddy + " to see you?", "Confirmation", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
                bAccept = true;
            else
                bAccept = false;
        }

        private void MSN_OnBuddyAddYouRequest(object sender, string buddy, ref bool bAccept)
        {
            object[] inVar = { sender, buddy, bAccept };
            this.Invoke(new OnBuddyAddYouRequestEventHandler(OnBuddyAddYouRequest), inVar);
            bAccept = (bool)inVar[2];
        }

        private void OnDeleteBuddy(object sender, string buddy)
        {
            MSNBuddy b = msn.BuddyList[buddy] as MSNBuddy;
            (b.Tag as TreeNode).Remove();
        }

        private void MSN_OnDeleteBuddy(object sender, string buddy)
        {
            this.Invoke(new OnBuddyEventHandle(OnDeleteBuddy), new object[] { sender, buddy });
        }

        private void OnBuddyStatusChanged(object sender, string buddy)
        {
            MSNBuddy b = msn.BuddyList[buddy] as MSNBuddy;

            if (b.PersonalMessage == "")
                (b.Tag as TreeNode).Text = b.Nickname;
            else
                (b.Tag as TreeNode).Text = b.Nickname + " - " + b.PersonalMessage;


            if (b.Blocked)
            {
                if (b.Status == MSNStatus.msnAppearOffline)
                {
                    (b.Tag as TreeNode).ImageKey = "offlineblock";
                    (b.Tag as TreeNode).SelectedImageKey = "offlineblock";
                }
                else
                {
                    (b.Tag as TreeNode).ImageKey = "onlineblock";
                    (b.Tag as TreeNode).SelectedImageKey = "onlineblock";
                }
            }
            else
            {
                (b.Tag as TreeNode).ImageKey = MSNStatusToImageIndex(b.Status);
                (b.Tag as TreeNode).SelectedImageKey = MSNStatusToImageIndex(b.Status);
            }
        }

        private void MSN_OnBuddyStatusChanged(object sender, string buddy)
        {
            this.Invoke(new OnBuddyEventHandle(OnBuddyStatusChanged), new object[] { sender,buddy });
        }

        private void OnStatusChanged(object sender, EventArgs e)
        {
            rootNode.ImageKey = MSNStatusToImageIndex(((MSNClient)sender).Status);
            rootNode.SelectedImageKey = rootNode.ImageKey;
            cbStatus.SelectedIndex = (int)((MSNClient)sender).Status;
        }

        private void MSN_OnStatusChanged(object sender, EventArgs e)
        {
            this.Invoke(new EventHandler(OnStatusChanged), new object[] { sender ,e});
        }

        private void OnReceiveBuddyList(Object sender, EventArgs e)
        {
            MSNClient inMSN = (MSNClient)sender;
            foreach (System.Collections.DictionaryEntry o in inMSN.BuddyList)
            {
                MSNBuddy b = (MSNBuddy)o.Value;

                TreeNode gn = FindNode(rootNode, b.GroupID);

                TreeNode bn = new TreeNode(b.Nickname);
                bn.Tag = b;
                b.Tag = bn;

                if (gn == null)
                    rootNode.Nodes.Add(bn);
                else
                    gn.Nodes.Add(bn);
            }
            rootNode.ExpandAll();

            //msn.Nickname = "[" + (new System.DateTime()).ToLongTimeString() + "] " + msn.Nickname;
        }

        private void OnReceiveGroupList(Object sender, EventArgs e)
        {
            MSNClient inMSN = (MSNClient)sender;
            foreach (System.Collections.DictionaryEntry o in inMSN.GroupList)
            {
                MSNGroup g = (MSNGroup)o.Value;

                TreeNode gn = new TreeNode(g.GroupName);
                rootNode.Nodes.Add(gn);
                gn.SelectedImageKey = "group";
                gn.ImageKey = "group";
                gn.Tag = g;
                g.Tag = gn;
            }
            rootNode.ExpandAll();
        }

        private void OnPersonalMessageChanged(object sender, EventArgs e)
        {
            if (msn.PersonalMessage != "")
                rootNode.Text = msn.Nickname + " - " + msn.PersonalMessage;
        }

        private void OnLogin(object sender, EventArgs e)
        {
            rootNode = new TreeNode(msn.Account);

            cmdLogin.Enabled = false;
            cmdLogout.Enabled = true;
            cbStatus.Enabled = true;
            txtNickname.Enabled = true;
        

            tvMSN.Nodes.Add(rootNode);

            rootNode.Text = msn.Account;

            tabControl1.SelectedIndex = 1;

            lblStatus.Text = "Login OK.";
        }

        private void OnLogout(object sender, EventArgs e)
        {
            tvMSN.Nodes.Clear();

            txtNickname.Enabled = false;
            cmdLogin.Enabled = true;
            cmdLogout.Enabled = false;
            cbStatus.Enabled = false;
            mmAction.Enabled = false;

            tabControl1.SelectedIndex = 0;

            lblStatus.Text = "Logout.";
        }

        private void timerKeepAliveExecute(Object sender,EventArgs e)
        {
            if (msn.Logined) msn.SendKeepAlive();
        }

        private void OnTextMessageReceived(object sender, MSNChatSession chatSession, TextMessage message)
        {
            if (chatSession.Tag == null) return;

            string messageLine = null;

            if (message.BuddyNickname != null)
                messageLine = message.BuddyNickname + " Said: " + message.Text + "\r\n" ;
            else
                messageLine = message.Buddy + " Said: " + message.Text + "\r\n" ;

            FrmChatSession frmChat = chatSession.Tag as FrmChatSession;

            frmChat.messageReceived(messageLine);
            frmChat.Show();

            txtLog.Text = messageLine + txtLog.Text;

            lblStatus.Text = "Receive message from "+ message.Buddy;

            /*TextMessage msg = new TextMessage();
            msg.Buddy = chatSession.ChatPartner;
            msg.Text = message.Text;
            msn.SendMessage(msg);*/
        }

        private void MSN_OnTextMessageReceived(object sender, MSNChatSession chatSession, TextMessage message)
        {
            this.Invoke(new OnTextMessageEventHandler(OnTextMessageReceived), new object[] { sender, chatSession, message });        
        }

        private void MSN_OnReceiveGroupList(object sender, EventArgs e)
        {
            this.Invoke(new EventHandler(OnReceiveGroupList), new object[] { sender ,e});
        }

        private void MSN_OnReceiveBuddyList(object sender, EventArgs e)
        {
            this.Invoke(new EventHandler(OnReceiveBuddyList), new object[] { sender,e });
        }

        private void OnLog(object sender, string statusMessage)
        {
            if (statusMessage.Length < 50)
                lblStatus.Text = statusMessage;
            else
                lblStatus.Text = statusMessage.Substring(0, 50);

            txtLog.Text = statusMessage + "\r\n" + txtLog.Text;
        }

        private void UpdateButtonStatus()
        {

        }

        private void OnNicknameChanged(object sender, EventArgs e)
        {
            if (msn.PersonalMessage != "")
                rootNode.Text = msn.Nickname + " - " + msn.PersonalMessage;
            else
                rootNode.Text = ((MSNClient)sender).Nickname;

            txtNickname.Text = ((MSNClient)sender).Nickname; 
        }

        private void MSN_OnNicknameChanged(object sender, EventArgs e)
        {
            this.Invoke(new EventHandler(OnNicknameChanged), new object[] { sender ,e});
        }

        private void MSN_OnLog(object sender, string statusMessage)
        {
            this.Invoke(new OnLogEventHandler(OnLog), new object[] { sender,statusMessage });
        }

        private void MSN_OnError(object sender, string errorMessage)
        {
            this.Invoke(new OnErrorEventHandler(OnLog), new object[] { sender, errorMessage });
        }

        private void MSN_OnLogin(object sender, EventArgs e)
        {
            this.Invoke(new EventHandler(OnLogin));
        }

        private void MSN_OnPersonalMessageChanged(object sender, EventArgs e)
        {
            this.Invoke(new EventHandler(OnPersonalMessageChanged));
        }

        private void MSN_OnMPOP(object sender, EventArgs e)
        {
            this.Invoke(new EventHandler(OnMPOP));
        }

        private void MSN_OnLogout(object sender, EventArgs e)
        {
            this.Invoke(new EventHandler(OnLogout));
        }

        private void fontDialog1_Apply(object sender, EventArgs e)
        {
        }

        private void cmdLogin_Click(object sender, EventArgs e)
        {
            tvMSN.Nodes.Clear();

            msn.Account = txtEmail.Text;
            msn.Password = txtPassword.Text;
            msn.Login();
        }

        private void toolStripStatusLabel1_Click(object sender, EventArgs e)
        {

        }

        private void cbStatus_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (msn.Status != ((MSNStatus)cbStatus.SelectedIndex))
                msn.Status = ((MSNStatus)cbStatus.SelectedIndex);
        }

        private void txtNickname_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                if (txtNickname.Text == "") txtNickname.Text = msn.Account;
                msn.Nickname = txtNickname.Text;                
            }
        }

        private void blockToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (msn.Logined && (tvMSN.SelectedNode.Tag != null))
                msn.BlockBuddy((tvMSN.SelectedNode.Tag as MSNBuddy).Email);
        }

        private void tvMSN_AfterSelect(object sender, TreeViewEventArgs e)
        {
            if (msn.Logined && (e.Node.Tag != null))
                mmAction.Enabled = (e.Node.Tag is MSNBuddy);
        }

        private void unblockToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (msn.Logined && (tvMSN.SelectedNode.Tag != null))
                msn.UnblockBuddy((tvMSN.SelectedNode.Tag as MSNBuddy).Email);
        }

        private void deleteToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (msn.Logined && (tvMSN.SelectedNode.Tag != null))
                msn.DeleteBuddy((tvMSN.SelectedNode.Tag as MSNBuddy).Email);
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void addBuddyToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //add buddy
            if (msn.Logined)
            {
                InputMessageForm frmInput = new InputMessageForm();
                frmInput.setCaption("Add Buddy:");
                frmInput.ShowDialog();

                if ((frmInput.Result == DialogResult.OK) && (frmInput.MessageStr != ""))
                    msn.AddBuddy(frmInput.MessageStr);
            }

        }

        private void logoutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (mmLogout.HasDropDownItems)
            {
                if (sender != mmLogout)
                {
                    if ((sender as ToolStripMenuItem).Tag == null)
                        msn.LogoutAll();
                    else
                        msn.LogoutOtherMachine(((sender as ToolStripMenuItem).Tag as MSNMPOP).MachineId);
                }
            }
            else
                msn.LogoutAll();
        }

        private TreeNode FindNode(TreeNode tnParent, string strValue)
        {

            if (tnParent == null) return null;

            if ((tnParent.Tag is MSNGroup) && ((tnParent.Tag as MSNGroup).GroupID == strValue))
                return tnParent;

            TreeNode tnRet = null;

            foreach (TreeNode tn in tnParent.Nodes)
            {
                tnRet = FindNode(tn, strValue);
                if (tnRet != null) break;
            }
            return tnRet;
        }

        private string MSNStatusToImageIndex(MSNStatus status)
        {
            switch (status)
            {
                case MSNStatus.msnIdle:
                case MSNStatus.msnAway:
                case MSNStatus.msnBeRightBack:
                case MSNStatus.msnOutLunch:
                    return "away";

                case MSNStatus.msnOnline:
                    return "online";

                case MSNStatus.msnBusy:
                case MSNStatus.msnOnThePhone:
                    return "busy";

                default:
                    return "offline";
            }
        }

        private void sendMessageToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (tvMSN.SelectedNode != null)
            {
                InputMessageForm frmInput = new InputMessageForm();
                frmInput.setCaption("Instant Message:");
                frmInput.ShowDialog();

                if ((frmInput.Result == DialogResult.OK) && (frmInput.MessageStr != ""))
                {
                    TextMessage msg = new TextMessage();
                    msg.Buddy = (tvMSN.SelectedNode.Tag as MSNBuddy).Email;
                    msg.Text =frmInput.MessageStr;
                    msn.SendMessage(msg);
                }
            }
        }

        private void snedOfflineMessageToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (tvMSN.SelectedNode != null)
            {
                InputMessageForm frmInput = new InputMessageForm();
                frmInput.setCaption("Offline Message:");
                frmInput.ShowDialog();

                if ((frmInput.Result == DialogResult.OK) && (frmInput.MessageStr != ""))
                {
                    msn.SendOfflineMessage((tvMSN.SelectedNode.Tag as MSNBuddy).Email,frmInput.MessageStr);
                }
            }
        }

        private void loginToolStripMenuItem_Click(object sender, EventArgs e)
        {
            cmdLogin_Click(sender,e);
        }

        private void sendShakeToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

        private void cmdLogout_Click(object sender, EventArgs e)
        {
            msn.Logout();
        }

        private void toolStripMenuItem5_Click(object sender, EventArgs e)
        {
            //add buddy
            if (msn.Logined)
            {
                InputMessageForm frmInput = new InputMessageForm();
                frmInput.setCaption("Personal Message:");
                frmInput.setValue(msn.PersonalMessage);

                frmInput.ShowDialog();

                if ((frmInput.Result == DialogResult.OK) && (frmInput.MessageStr != ""))
                    msn.PersonalMessage = frmInput.MessageStr;
            }
        }

    }
}